// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: commonmodule/commonmodule.proto

package openfmb.commonmodule;

/**
 * <pre>
 * Constant Reactive Power (Fixed VAr) Function
 * </pre>
 *
 * Protobuf type {@code commonmodule.WSPC}
 */
public final class WSPC extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:commonmodule.WSPC)
    WSPCOrBuilder {
private static final long serialVersionUID = 0L;
  // Use WSPC.newBuilder() to construct.
  private WSPC(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private WSPC() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new WSPC();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_WSPC_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_WSPC_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.commonmodule.WSPC.class, openfmb.commonmodule.WSPC.Builder.class);
  }

  public static final int MODENA_FIELD_NUMBER = 1;
  private boolean modEna_ = false;
  /**
   * <pre>
   * Constant Reactive Power Mode Enable
   * </pre>
   *
   * <code>bool modEna = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The modEna.
   */
  @java.lang.Override
  public boolean getModEna() {
    return modEna_;
  }

  public static final int WPARAMETER_FIELD_NUMBER = 2;
  private openfmb.commonmodule.OperationDWGC wParameter_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.OperationDWGC wParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the wParameter field is set.
   */
  @java.lang.Override
  public boolean hasWParameter() {
    return wParameter_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.OperationDWGC wParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The wParameter.
   */
  @java.lang.Override
  public openfmb.commonmodule.OperationDWGC getWParameter() {
    return wParameter_ == null ? openfmb.commonmodule.OperationDWGC.getDefaultInstance() : wParameter_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.OperationDWGC wParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.OperationDWGCOrBuilder getWParameterOrBuilder() {
    return wParameter_ == null ? openfmb.commonmodule.OperationDWGC.getDefaultInstance() : wParameter_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (modEna_ != false) {
      output.writeBool(1, modEna_);
    }
    if (wParameter_ != null) {
      output.writeMessage(2, getWParameter());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (modEna_ != false) {
      size += com.google.protobuf.CodedOutputStream
        .computeBoolSize(1, modEna_);
    }
    if (wParameter_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getWParameter());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.commonmodule.WSPC)) {
      return super.equals(obj);
    }
    openfmb.commonmodule.WSPC other = (openfmb.commonmodule.WSPC) obj;

    if (getModEna()
        != other.getModEna()) return false;
    if (hasWParameter() != other.hasWParameter()) return false;
    if (hasWParameter()) {
      if (!getWParameter()
          .equals(other.getWParameter())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    hash = (37 * hash) + MODENA_FIELD_NUMBER;
    hash = (53 * hash) + com.google.protobuf.Internal.hashBoolean(
        getModEna());
    if (hasWParameter()) {
      hash = (37 * hash) + WPARAMETER_FIELD_NUMBER;
      hash = (53 * hash) + getWParameter().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.commonmodule.WSPC parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.WSPC parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.WSPC parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.WSPC parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.WSPC parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.WSPC parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.WSPC parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.WSPC parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.WSPC parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.WSPC parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.WSPC parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.WSPC parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.commonmodule.WSPC prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Constant Reactive Power (Fixed VAr) Function
   * </pre>
   *
   * Protobuf type {@code commonmodule.WSPC}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:commonmodule.WSPC)
      openfmb.commonmodule.WSPCOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_WSPC_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_WSPC_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.commonmodule.WSPC.class, openfmb.commonmodule.WSPC.Builder.class);
    }

    // Construct using openfmb.commonmodule.WSPC.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      modEna_ = false;
      wParameter_ = null;
      if (wParameterBuilder_ != null) {
        wParameterBuilder_.dispose();
        wParameterBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_WSPC_descriptor;
    }

    @java.lang.Override
    public openfmb.commonmodule.WSPC getDefaultInstanceForType() {
      return openfmb.commonmodule.WSPC.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.commonmodule.WSPC build() {
      openfmb.commonmodule.WSPC result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.commonmodule.WSPC buildPartial() {
      openfmb.commonmodule.WSPC result = new openfmb.commonmodule.WSPC(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.commonmodule.WSPC result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.modEna_ = modEna_;
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.wParameter_ = wParameterBuilder_ == null
            ? wParameter_
            : wParameterBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.commonmodule.WSPC) {
        return mergeFrom((openfmb.commonmodule.WSPC)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.commonmodule.WSPC other) {
      if (other == openfmb.commonmodule.WSPC.getDefaultInstance()) return this;
      if (other.getModEna() != false) {
        setModEna(other.getModEna());
      }
      if (other.hasWParameter()) {
        mergeWParameter(other.getWParameter());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 8: {
              modEna_ = input.readBool();
              bitField0_ |= 0x00000001;
              break;
            } // case 8
            case 18: {
              input.readMessage(
                  getWParameterFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private boolean modEna_ ;
    /**
     * <pre>
     * Constant Reactive Power Mode Enable
     * </pre>
     *
     * <code>bool modEna = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The modEna.
     */
    @java.lang.Override
    public boolean getModEna() {
      return modEna_;
    }
    /**
     * <pre>
     * Constant Reactive Power Mode Enable
     * </pre>
     *
     * <code>bool modEna = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @param value The modEna to set.
     * @return This builder for chaining.
     */
    public Builder setModEna(boolean value) {

      modEna_ = value;
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Constant Reactive Power Mode Enable
     * </pre>
     *
     * <code>bool modEna = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return This builder for chaining.
     */
    public Builder clearModEna() {
      bitField0_ = (bitField0_ & ~0x00000001);
      modEna_ = false;
      onChanged();
      return this;
    }

    private openfmb.commonmodule.OperationDWGC wParameter_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.OperationDWGC, openfmb.commonmodule.OperationDWGC.Builder, openfmb.commonmodule.OperationDWGCOrBuilder> wParameterBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.OperationDWGC wParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the wParameter field is set.
     */
    public boolean hasWParameter() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.OperationDWGC wParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The wParameter.
     */
    public openfmb.commonmodule.OperationDWGC getWParameter() {
      if (wParameterBuilder_ == null) {
        return wParameter_ == null ? openfmb.commonmodule.OperationDWGC.getDefaultInstance() : wParameter_;
      } else {
        return wParameterBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.OperationDWGC wParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setWParameter(openfmb.commonmodule.OperationDWGC value) {
      if (wParameterBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        wParameter_ = value;
      } else {
        wParameterBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.OperationDWGC wParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setWParameter(
        openfmb.commonmodule.OperationDWGC.Builder builderForValue) {
      if (wParameterBuilder_ == null) {
        wParameter_ = builderForValue.build();
      } else {
        wParameterBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.OperationDWGC wParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeWParameter(openfmb.commonmodule.OperationDWGC value) {
      if (wParameterBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          wParameter_ != null &&
          wParameter_ != openfmb.commonmodule.OperationDWGC.getDefaultInstance()) {
          getWParameterBuilder().mergeFrom(value);
        } else {
          wParameter_ = value;
        }
      } else {
        wParameterBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.OperationDWGC wParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearWParameter() {
      bitField0_ = (bitField0_ & ~0x00000002);
      wParameter_ = null;
      if (wParameterBuilder_ != null) {
        wParameterBuilder_.dispose();
        wParameterBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.OperationDWGC wParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.OperationDWGC.Builder getWParameterBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getWParameterFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.OperationDWGC wParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.OperationDWGCOrBuilder getWParameterOrBuilder() {
      if (wParameterBuilder_ != null) {
        return wParameterBuilder_.getMessageOrBuilder();
      } else {
        return wParameter_ == null ?
            openfmb.commonmodule.OperationDWGC.getDefaultInstance() : wParameter_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.OperationDWGC wParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.OperationDWGC, openfmb.commonmodule.OperationDWGC.Builder, openfmb.commonmodule.OperationDWGCOrBuilder> 
        getWParameterFieldBuilder() {
      if (wParameterBuilder_ == null) {
        wParameterBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.OperationDWGC, openfmb.commonmodule.OperationDWGC.Builder, openfmb.commonmodule.OperationDWGCOrBuilder>(
                getWParameter(),
                getParentForChildren(),
                isClean());
        wParameter_ = null;
      }
      return wParameterBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:commonmodule.WSPC)
  }

  // @@protoc_insertion_point(class_scope:commonmodule.WSPC)
  private static final openfmb.commonmodule.WSPC DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.commonmodule.WSPC();
  }

  public static openfmb.commonmodule.WSPC getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<WSPC>
      PARSER = new com.google.protobuf.AbstractParser<WSPC>() {
    @java.lang.Override
    public WSPC parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<WSPC> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<WSPC> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.commonmodule.WSPC getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

